/**
 *	@file	vector_test.cpp
 *	@brief	vector NX̃eXg
 *	@author	tenk*
 *	@date	2010-??
 *	@note
 *		ƂƎOasserteXgĂ̂unitst.hŏ̂
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <string>

#include "../ya_vector.h"


#include "unitst.h"


UNITST_TEST(vector_test) {
	ya_vector<char>	ac10(10);
	char	buf[256];
	memset(buf, 0, sizeof buf);
	UNITST_EQ_I(ac10.size()    , 10);
	UNITST_EQ_I(ac10.capacity(), 10);
	UNITST_EQ_I(ac10.max_size(), 10);
	UNITST_EQ_I(ac10.empty()   ,  0);
	ac10.assign(10, '\0');
	UNITST_EQ_MEM(&ac10[0], buf, 10);
	UNITST_CHECK(ac10 == ac10);

	for (unsigned i = 0; i < 9; ++i) {
		ac10[i] = char('0' + i);
		UNITST_EQ_I(ac10[i], char('0'+i));
	}

	ya_vector<char>	ac10b = ac10;
	UNITST_EQ_MEM(&ac10b[0], "012345678", 10);
	UNITST_CHECK(ac10 == ac10b);
	UNITST_CHECK(ac10 >= ac10b);
	UNITST_CHECK(ac10 <= ac10b);
	ac10b[0] = '9';
	UNITST_CHECK(ac10 != ac10b);
	UNITST_CHECK(ac10 <= ac10b);
	UNITST_CHECK(ac10 <  ac10b);
	UNITST_CHECK(ac10b != ac10);
	UNITST_CHECK(ac10b >= ac10);
	UNITST_CHECK(ac10b >  ac10);
	ac10 = ac10b;
	UNITST_CHECK(ac10 == ac10b);
	UNITST_CHECK(ac10 >= ac10b);
	UNITST_CHECK(ac10 <= ac10b);

	UNITST_EQ_I(ac10.front(), '9');
	UNITST_EQ_I(ac10.back(), '\0');
	UNITST_EQ_I(*ac10.begin(), '9');
	UNITST_EQ_I(*(ac10.end() - 1), '\0');
	UNITST_EQ_I(*(ac10.end() - 2), '8');
	UNITST_EQ_I(*ac10.rbegin(), '\0');
	UNITST_EQ_I(*(ac10.rend()-1), '9');

	for (unsigned i = 0; i < 9; ++i) {
		ac10.at(i) = char('A' + i);
		UNITST_EQ_I(ac10.at(i), char('A'+i));
	}

	//UNITST_ASSERT_THROW( ac10.at(11), std::out_of_range );
	UNITST_ASSERT_ANY_THROW( ac10.at(11) );
	UNITST_ASSERT_ANY_THROW( ac10.at(unsigned(-1)) );

	ac10b.assign(10, '@');
	using std::swap;
	swap(ac10, ac10b);
	UNITST_EQ_MEM(&ac10 [0], "@@@@@@@@@@", 10);
	UNITST_EQ_MEM(&ac10b[0], "ABCDEFGHI\0", 10);


	ya_vector<int> ary(5);

	UNITST_EQ_I(ary.size(), 5);
	UNITST_GE_I(ary.max_size(), 5);
	UNITST_GE_I(ary.capacity(), 5);
	UNITST_EQ_I(ary.empty()   , 0);

	UNITST_ASSERT_NO_THROW(ary.at(4)=4);
	UNITST_ASSERT_THROW(ary.at(5)=5, std::out_of_range );

	int n = 0;
	for (n = 0; n < 5; ++n)
		ary[n] = n;
	for (n = 0; n < 5; ++n)
		ary[n] = ary[n]+1;

	UNITST_EQ_I(ary.front(), 1);
	UNITST_EQ_I(ary.back(), 5);

	ya_vector<int>::iterator it;
	for (n = 1, it = ary.begin(); it != ary.end(); ++it, ++n)
		UNITST_EQ(*it, n);

	ya_vector<int>::reverse_iterator ri;
	for (n = 5, ri = ary.rbegin(); ri != ary.rend(); ++ri, --n)
		UNITST_EQ(*ri, n);

	ya_vector<int>::const_iterator cit;
	for (n = 1, cit = ary.cbegin(); cit != ary.cend(); ++cit, ++n)
		UNITST_EQ(*cit, n);

	ya_vector<int>::const_reverse_iterator cri;
	for (n = 5, cri = ary.crbegin(); cri != ary.crend(); ++cri, --n)
		UNITST_EQ(*cri, n);


	ya_vector<int> ary2(ary);
	UNITST_EQ_MEM(&ary2[0], &ary[0], sizeof(ary[0])*ary.size());
	UNITST_EQ_I(ary == ary2, true );
	UNITST_EQ_I(ary != ary2, false);
	UNITST_EQ_I(ary <  ary2, false);
	UNITST_EQ_I(ary <= ary2, true );
	UNITST_EQ_I(ary >  ary2, false);
	UNITST_EQ_I(ary >= ary2, true );

	ya_vector<int> ary3 = ary;
	UNITST_EQ_MEM(&ary3[0], &ary[0], sizeof(ary[0])*ary.size());
	UNITST_EQ(ary3, ary);
	ary3[2] = 10;
	UNITST_EQ_I((ary == ary3), false);
	UNITST_EQ_I((ary != ary3), true );
	UNITST_EQ_I((ary <	ary3), true );
	UNITST_EQ_I((ary <= ary3), true );
	UNITST_EQ_I((ary >	ary3), false);
	UNITST_EQ_I((ary >= ary3), false);
	ary3[2] = 1;
	UNITST_EQ_I((ary == ary3), false);
	UNITST_EQ_I((ary != ary3), true );
	UNITST_EQ_I((ary <	ary3), false);
	UNITST_EQ_I((ary <= ary3), false);
	UNITST_EQ_I((ary >	ary3), true );
	UNITST_EQ_I((ary >= ary3), true );

	ya_vector<int> ary4 = ary3;

	ary2.swap(ary4);
	UNITST_EQ(ary2, ary3);
	UNITST_EQ(ary4, ary);

	std::swap(ary2, ary4);
	UNITST_EQ(ary2, ary);
	UNITST_EQ(ary4, ary3);

	//array<int, 10> ary5 = ary;
	ya_vector<int> ary5;
	ary5.assign(ary.begin(), ary.end());

	UNITST_EQ_MEM(&ary5[0], &ary[0], sizeof(ary[0])*ary.size());

	for (n = 0; n < int(ary5.size()); ++n)
		ary5[n] = (n+1)*2;
	//x ary4 = ary5;
	//ary4.assign(ary5.begin(), ary5.begin()+5);
	//UNITST_EQ_MEM(&ary4[0], &ary5[0], sizeof ary4);

	ary4.assign(5U, 500);
	for (n = 0; n < 5; ++n)
		UNITST_EQ_I(ary4[n], 500);
}



UNITST_TEST(vector_2_test) {
	ya_vector<int> ary(5);

	UNITST_EQ_I(ary.size(), 5);
	UNITST_EQ_I(ary.max_size(), 5);
	UNITST_EQ_I(ary.capacity(), 5);
	UNITST_EQ_I(ary.empty()   , 0);

	UNITST_ASSERT_ANY_THROW( (ary.at(5) = 5) );

	int n = 0;
	for (n = 0; n < 5; ++n)
		ary[n] = n;
	for (n = 0; n < 5; ++n)
		ary[n] = ary[n]+1;

	UNITST_EQ_I(ary.front(), 1);
	UNITST_EQ_I(ary.back(), 5);

	ya_vector<int>::iterator it;
	for (n = 1, it = ary.begin(); it != ary.end(); ++it, ++n)
		UNITST_EQ(*it, n);

	ya_vector<int>::reverse_iterator ri;
	for (n = 5, ri = ary.rbegin(); ri != ary.rend(); ++ri, --n)
		UNITST_EQ(*ri, n);

	ya_vector<int> ary2(ary);
	UNITST_EQ_MEM(&ary2[0], &ary[0], sizeof(ary[0])*ary.size());
	UNITST_EQ_I(ary == ary2, true );
	UNITST_EQ_I(ary != ary2, false);
	UNITST_EQ_I(ary <  ary2, false);
	UNITST_EQ_I(ary <= ary2, true );
	UNITST_EQ_I(ary >  ary2, false);
	UNITST_EQ_I(ary >= ary2, true );

	ya_vector<int> ary3;
	ary3 = ary;
	UNITST_EQ_MEM(&ary3[0], &ary[0], sizeof(ary[0])*ary.size());
	UNITST_EQ(ary3, ary);
	ary3[2] = 10;
	UNITST_EQ_I((ary == ary3), false);
	UNITST_EQ_I((ary != ary3), true );
	UNITST_EQ_I((ary <	ary3), true );
	UNITST_EQ_I((ary <= ary3), true );
	UNITST_EQ_I((ary >	ary3), false);
	UNITST_EQ_I((ary >= ary3), false);
	ary3[2] = 1;
	UNITST_EQ_I((ary == ary3), false);
	UNITST_EQ_I((ary != ary3), true );
	UNITST_EQ_I((ary <	ary3), false);
	UNITST_EQ_I((ary <= ary3), false);
	UNITST_EQ_I((ary >	ary3), true );
	UNITST_EQ_I((ary >= ary3), true );

	ya_vector<int> ary4 = ary3;

	ary2.swap(ary4);
	UNITST_EQ(ary2, ary3);
	UNITST_EQ(ary4, ary);

	std::swap(ary2, ary4);
	UNITST_EQ(ary2, ary);
	UNITST_EQ(ary4, ary3);

	ya_vector<int> ary5 = ary;
	UNITST_EQ_MEM(&ary5[0], &ary[0], sizeof(ary[0])*ary.size());
	ary5.resize(10);

	for (n = 0; n < int(ary5.size()); ++n)
		ary5[n] = (n+1)*2;
	ary4.assign(ary5.begin(), ary5.begin()+ 5);
	// ary4 = ary5;
	UNITST_EQ_MEM(&ary4[0], &ary5[0], sizeof(ary5[0])*5);

	ary4.assign(5U, (int)500);
	for (n = 0; n < 5; ++n)
		UNITST_EQ_I(ary4[n], 500);
}



UNITST_TEST(vector_pushpop_test) {
	ya_vector<int> v;
	int n;

	UNITST_EQ_I(v.size(), 0);
	UNITST_EQ_I(v.empty()	, 1);

	v.push_back(1);
	UNITST_EQ(v[0], 1);
	v.push_back(2);
	UNITST_EQ(v[1], 2);
	v.pop_back();
	v.pop_back();

	v.reserve(5);
	UNITST_GE_I(v.max_size(), 5);
	UNITST_GE_I(v.capacity(), 5);

	for (n = 0; n < 5; ++n) {
		v.push_back(n+1);
		UNITST_EQ_I( v[n] ,v.at(n) );
		UNITST_EQ_I(v.size(), unsigned(n+1));
		UNITST_EQ_I(v.empty()	, 0);
		UNITST_EQ_I(v.front(), 1);
		UNITST_EQ_I(v.back(), n+1);
	}
	UNITST_ASSERT_ANY_THROW( (v.at(5) = 5) );

	for (n = 5; --n >= 5;) {
		UNITST_EQ_I(v.back(), n+1);
		v.pop_back();
	}

	v.clear();
	UNITST_EQ_I(v.size()	, 0);
	UNITST_EQ_I(v.empty()	, 1);

	v.resize(3);
	UNITST_EQ_I(v.size()	, 3);
	UNITST_EQ_I(v.empty()	, 0);

	v.assign(3U, (int)999);
	for (n = 0; n < 3; ++n)
		UNITST_EQ_I(v[n], 999);
}


UNITST_TEST(vector_pushpop_test2) {
	ya_vector<std::string> v;
	int n;

	UNITST_EQ_I(v.size()	, 0);
	UNITST_EQ_I(v.empty()	, 1);

	v.reserve(5);
	UNITST_GE_I(v.max_size(), 5);
	UNITST_GE_I(v.capacity(), 5);

	static const char* strs[] = {"0","1","2","3","4","5","6"};
	for (n = 0; n < 5; ++n) {
		v.push_back( std::string(strs[n+1]) );
		UNITST_EQ_STRING( v[n] ,v.at(n) );
		UNITST_EQ_I(v.size(), unsigned(n+1));
		UNITST_EQ_I(v.empty()	, 0);
		UNITST_EQ_STRING(v.front(),std::string(strs[1]));
		UNITST_EQ_STRING(v.back(), std::string(strs[n+1]));
	}
	UNITST_ASSERT_ANY_THROW( (v.at(5) = 5) );

	for (n = 5; --n >= 5;) {
		UNITST_EQ_STRING(v.back(), std::string(strs[n+1]));
		v.pop_back();
	}

	v.clear();
	UNITST_EQ_I(v.size()	, 0);
	UNITST_EQ_I(v.empty()	, 1);

	v.resize(3);
	UNITST_EQ_I(v.size()	, 3);
	UNITST_EQ_I(v.empty()	, 0);

	v.assign(3U, std::string("str"));
	for (n = 0; n < 3; ++n)
		UNITST_EQ_STRING(v[n], std::string("str"));
}



UNITST_TEST(vector_insert_test) {
	ya_vector<int> v;

	v.insert( v.begin(), 1 );
	UNITST_EQ_I(v.size(), 1);
	UNITST_EQ_I(v.empty()	, 0);

	v.insert( v.end(), 5 );
	UNITST_EQ_I(v.size(), 2);
	UNITST_EQ_I(v.empty()	, 0);
	static const int m2[] = { 1, 5 };
	UNITST_EQ_MEM(&v[0], m2, sizeof m2);

	v.insert( v.begin()+1, 3 );
	UNITST_EQ_I(v.size(), 3);
	UNITST_EQ_I(v.empty()	, 0);
	static const int m3[] = { 1, 3, 5 };
	UNITST_EQ_MEM(&v[0], m3, sizeof m3);

	v.erase( v.begin()+1 );
	UNITST_EQ_I(v.size()  , 2);
	UNITST_EQ_I(v.empty() , 0);
	UNITST_EQ_MEM(&v[0], m2, sizeof m2);

	static const int mi[] = {2,3,4};
	v.insert( v.begin()+1, mi, mi+3 );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_I(v.empty() , 0);
	static const int m5[] = { 1, 2, 3, 4, 5 };
	UNITST_EQ_MEM(&v[0], m5, sizeof m5);

	v.erase( v.begin() );
	UNITST_EQ_I(v.size()  , 4);
	UNITST_EQ_I(v.empty() , 0);
	static const int m4a[] = { 2, 3, 4, 5 };
	UNITST_EQ_MEM(&v[0], m4a, sizeof m4a);

	v.erase( v.begin()+1, v.end()-1 );
	UNITST_EQ_I(v.size()  , 2);
	UNITST_EQ_I(v.empty() , 0);
	static const int m2b[] = { 2, 5 };
	UNITST_EQ_MEM(&v[0], m2b, sizeof m2b);

	v.insert( v.end(), mi, mi+3 );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_I(v.empty() , 0);
	v[0] = 1;
	static const int m5b[] = { 1, 5, 2, 3, 4, };
	UNITST_EQ_MEM(&v[0], m5b, sizeof m5b);

	ya_vector<int> v2;		//x v2.reserve(10);
	v2.assign(v.begin(), v.end());
	UNITST_EQ_I(v2.size()  , 5);
	UNITST_EQ_I(v2.empty() , 0);
	UNITST_EQ_MEM(&v2[0], m5b, sizeof m5b);
	//x v2.reserve(10);
	v2.insert(v2.end(), m5b, m5b+5);
	static const int m10b[] = { 1, 5, 2, 3, 4, 1, 5, 2, 3, 4, };
	UNITST_EQ_MEM(&v2[0], m10b, sizeof m10b);

	v.erase( v.end()-2, v.end() );
	UNITST_EQ_I(v.size()  , 3);
	UNITST_EQ_I(v.empty() , 0);
	static int m3b[] = { 1, 5, 2, };
	UNITST_EQ_MEM(&v[0], m3b, sizeof m3b);

	v.erase( v.begin(), v.end() );
	UNITST_EQ_I(v.size()  , 0);
	UNITST_EQ_I(v.empty() , 1);

	v.insert( v.begin(), 5U, 123 );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_I(v.empty() , 0);
	static int m5c[] = { 123, 123, 123, 123, 123 };
	UNITST_EQ_MEM(&v[0], m5c, sizeof m5c);

	v = v2;
	v.resize(5);

	UNITST_ASSERT_ANY_THROW( v.insert( (int*)NULL, 1 ) );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_MEM(&v[0], m5b, sizeof m5b);
	UNITST_ASSERT_ANY_THROW( v.insert( (int*)-1, 1 ) );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_MEM(&v[0], m5b, sizeof m5b);

	UNITST_ASSERT_ANY_THROW( v.insert( v.begin()-1, m5c, m5c+3 ) );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_MEM(&v[0], m5b, sizeof m5b);
	UNITST_ASSERT_ANY_THROW( v.insert( v.end()+1, m5c, m5c+3 ) );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_MEM(&v[0], m5b, sizeof m5b);

	//UNITST_ASSERT_ANY_THROW( v.erase( (int*)NULL ) );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_MEM(&v[0], m5b, sizeof m5b);
	//UNITST_ASSERT_ANY_THROW( v.erase( (int*)-1 ) );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_MEM(&v[0], m5b, sizeof m5b);

	//UNITST_ASSERT_ANY_THROW( v.erase( v.begin()-1, v.end() ) );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_MEM(&v[0], m5b, sizeof m5b);
	//UNITST_ASSERT_ANY_THROW( v.erase( v.begin(), v.end()+1 ) );
	UNITST_EQ_I(v.size()  , 5);
	UNITST_EQ_MEM(&v[0], m5b, sizeof m5b);
}
